<?php
/* Module développé par la société So Easy World.  http://www.soeasyworld.fr
 * Copyright (C) 2015 S. Lenormand <sebastien.lenormand@soeasyworld.fr>
 * Copyright (C) 2015 M. Guidez
 * Copyright (C) 2016 Nicolas ZABOURI <info@inovea-conseil.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

/**
 *   \file       htdocs/admin/catalogtreeadd_setupapage.php
 *   \ingroup    v
 *   \brief      Page to setup module catalogtreeadd
 */

$res = 0;
if (!$res && file_exists("../main.inc.php")) {
	$res = @include '../main.inc.php';
}                    // to work if your module directory is into dolibarr root htdocs directory
if (!$res && file_exists("../../main.inc.php")) {
	$res = @include '../../main.inc.php';
}            // to work if your module directory is into a subdir of root htdocs directory
if (!$res && file_exists("../../../main.inc.php")) {
	$res = @include '../../../main.inc.php';
}            // to work if your module directory is into a subdir of root htdocs directory
if (!$res && file_exists("../../../dolibarr/htdocs/main.inc.php")) {
	$res = @include '../../../dolibarr/htdocs/main.inc.php';
}     // Used on dev env only
if (!$res && file_exists("../../../../dolibarr/htdocs/main.inc.php")) {
	$res = @include '../../../../dolibarr/htdocs/main.inc.php';
}   // Used on dev env only
if (!$res) {
	die("Include of main fails");
}

global $langs, $user;

require_once DOL_DOCUMENT_ROOT .'/core/lib/admin.lib.php';
require_once '../lib/catalogtreeadd.lib.php';


$langs->load("admin");
$langs->load("catalogtreeadd@catalogtreeadd");

// Initialize technical object to manage hooks of page. Note that conf->hooks_modules contains array of hook context
$hookmanager->initHooks(array('catalogtreeaddsetup', 'globalsetup'));


if (!$user->admin) {
	accessforbidden();
}

$action = GETPOST("action");
$backtopage = GETPOST('backtopage', 'alpha');
$modulepart = GETPOST('modulepart', 'aZ09');	// Used by actions_setmoduleoptions.inc.php

$value = GETPOST('value', 'alpha');
$label = GETPOST('label', 'alpha');
$scandir = GETPOST('scan_dir', 'alpha');
$type = 'myobject';


$error = 0;
$setupnotempty = 0;

// Set this to 1 to use the factory to manage constants. Warning, the generated module will be compatible with version v15+ only
$useFormSetup = 1;

if (!class_exists('FormSetup')) {
	// For retrocompatibility Dolibarr < 16.0
	if (floatval(DOL_VERSION) < 16.0 && !class_exists('FormSetup')) {
		require_once __DIR__.'/../backport/v16/core/class/html.formsetup.class.php';
	} else {
		require_once DOL_DOCUMENT_ROOT.'/core/class/html.formsetup.class.php';
	}
}


$formSetup = new FormSetup($db);


$item = $formSetup->newItem('Checkbox');
$item->setAsYesNo();


/*
 *	Actions
 */

// For retrocompatibility Dolibarr < 15.0
if ( versioncompare(explode('.', DOL_VERSION), array(15)) < 0 && $action == 'update' && !empty($user->admin)) {
	$formSetup->saveConfFromPost();
}

if ($action == 'setvalue' && $user->admin) {
	$result = dolibarr_set_const($db, "CATALOGTREEADD_HAUTEUR", GETPOST("HautMod"), 'chaine', 0, '', $conf->entity);
	$result = dolibarr_set_const($db, "CATALOGTREEADD_LARGEUR", GETPOST("LargMod"), 'chaine', 0, '', $conf->entity);
	$result = dolibarr_set_const($db, "CATALOGTREEADD_TYPE", GETPOST("CATALOGTREEADD_TYPE",'chaine'), 'chaine', 0, '',
		$conf->entity);
	if ($result >= 0) {
		setEventMessage($langs->trans("ModifWin"));
	} else {
		setEventMessage($langs->trans("Error"), 'errors');
	}
}


/*
 * View
 */

$wikihelp = 'EN:Module_catalogtreeadd_En|FR:Module_catalogtreeadd|ES:Módulo_catalogtreeadd_Es';
llxHeader('', $langs->trans("catalogtreeaddSetup"), $wikihelp);

$linkback = '<a href="' . DOL_URL_ROOT . '/admin/modules.php">' . $langs->trans("BackToModuleList") . '</a>';
print_fiche_titre($langs->trans("catalogtreeaddSetup"), $linkback, 'setup');

print $langs->trans("catalogtreeaddDesc") . "<br>\n";

print '<br>';


$var = true;

$form = new Form($db);


print "<form method=\"post\" action=\"" . $_SERVER["PHP_SELF"] . "\">";
print '<input type="hidden" name="token" value="'.newToken().'">';
print '<input type="hidden" name="action" value="setvalue">';
print '<table class="noborder" width="100%">';
print '<tr class="liste_titre">';
print '<td width="120" colspan="3">' . $langs->trans("Parametre") . '</td>';
print "</tr>\n";
$var = !$var;
print '<tr><td width="15%" valign="top">';
print $langs->trans("TailleModCT") . '</td>';
print "<td width=\"15%\">" . $langs->trans("HautModCT") . ' : <input name="HautMod" size="15%" type="number" min="0" value="' . $conf->global->CATALOGTREEADD_HAUTEUR . '"> px </td><td width="60%" align="left">';
$htmltooltip = '' . $langs->trans("HautModCTTool");
print $form->textwithpicto('', $htmltooltip, 1, 0) . '</td></tr><tr><td></td><td>';
print $langs->trans("LargModCT") . ' : <input name="LargMod" size="15" type="number" min="0" value="' . $conf->global->CATALOGTREEADD_LARGEUR . '"> px </td><td width="60%" align="left">';
$htmltooltip = '' . $langs->trans("LargModCTTool");
print $form->textwithpicto('', $htmltooltip, 1, 0) . '</td></tr>';
print '<tr><td>';
if ($conf->global->CATALOGTREEADD_TYPE == 'label') {
	$s1 = "selected";
	$s2 = "";
} else {
	$s1 = "";
	$s2 = "selected";
}

print $langs->trans("CATALOGTREEADD_TYPE") . ' : <select name="CATALOGTREEADD_TYPE" ><option value="label" ' . $s1 . '>' . $langs->trans('LABEL') . '</option><option value="ref" ' . $s2 . '>' . $langs->trans('REF') . '</option></td><td width="60%" align="left">';
$htmltooltip = '' . $langs->trans("CATALOGTREEADD_TYPE_TOOLTIPS");
print $form->textwithpicto('', $htmltooltip, 1, 0) . '</td></tr>';

print '</table>';
print '<center><br><input type="submit" class="button" value="' . $langs->trans("Modifier") . '"></center>';



if ($action == 'edit') {
	print $formSetup->generateOutput(true);
	print '<br>';
} elseif (!empty($formSetup->items)) {
	print $formSetup->generateOutput();
	print '<div class="tabsAction">';
	print '</div>';
} else {
	print '<br>'.$langs->trans("NothingToSetup");
}


print '</form><br><br>';


llxFooter();

$db->close();
