<?php

/* Module développé par la société So Easy World.  http://www.soeasyworld.fr
 * Copyright (C) 2015 S. Lenormand <sebastien.lenormand@soeasyworld.fr>
 * Copyright (C) 2015 M. Guidez
 * Copyright (C) 2016 Nicolas ZABOURI <info@inovea-conseil.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

/**
 * \file    class/actions_catalostreeveiw.class.php
 * \ingroup catalogtreeadd
 * \brief   This file is an example hook overload class file
 *          Put some comments here
 */
/**
 * Class Actions_catatlogtreeview
 */
require_once DOL_DOCUMENT_ROOT . '/categories/class/categorie.class.php';
require_once DOL_DOCUMENT_ROOT . '/core/lib/treeview.lib.php';
dol_include_once('/milestone/class/actions_milestone.class.php');
require_once DOL_DOCUMENT_ROOT . '/core/class/html.form.class.php';

global $seller, $form, $langs;

$langs->load("categories");
$langs->load("catalogtreeadd@catalogtreeadd");


$type = (GETPOST('type') ? GETPOST('type') : 0);

class ActionsCatalogtreeAdd
{

	var $db;

	/**
	 * @var array Hook results. Propagated to $hookmanager->resArray for later reuse
	 */
	public $results = array();

	/**
	 * @var string String displayed by executeHook() immediately after return
	 */
	public $resprints;

	/**
	 * @var array Errors
	 */
	public $errors = array();

	/**
	 * Constructor
	 */
	function __construct($db)
	{
		$this->db = $db;
	}

	/**
	 * Function produit classé, mise en place du tableau
	 *
	 * @param mixed $tab_prod Tableau des produit
	 * @param mixed $cat_rowid ID de la catégorie
	 */
	function traitement_prod($tab_prod, $cat_rowid)
	{
		global $conf;
		$sizeoftab = count($tab_prod);

		for ($x = 0; $x < $sizeoftab; $x++) {
			if (($tab_prod[$x]['id_categorie'] == $cat_rowid)) {
				print '<table id=tabprod><tr><td id="ref" text-align="left"><input type="text" size="3" class="selectprod" data-idfournprice="' . $tab_prod[$x]['idfournprice'] . '" data-idprod="' . $tab_prod[$x]['rowid'] . '" data-refprod="' . $tab_prod[$x]['ref'] . '" />&nbsp;';
				if (($tab_prod[$x]['stock'] <= 0) && ($tab_prod[$x]['fk_product_type'] != 1) && !empty($conf->stock->enabled)) {
					print '<img src="' . DOL_URL_ROOT . '/theme/eldy/img/statut8.png"></img> ';
				} else {
					(print '<img src="' . DOL_URL_ROOT . '/theme/eldy/img/statut4.png"></img> ');
				}
				print($tab_prod[$x]['ref']);
				print '</td><td id="label" text-align="left" ><strong>';
				print($tab_prod[$x]['label']);
				print "</strong><br />";
				print($tab_prod[$x]['description']);
				print '</td><td id="prix" align="right">';
				print price($tab_prod[$x]['price'], null, null, null, null, $conf->global->MAIN_MAX_DECIMALS_UNIT,
					$conf->currency);
				print '</td><td id="stock" text-align="left">';
				if ($tab_prod[$x]['fk_product_type'] == 1 || empty($conf->stock->enabled)) {
					print ('');
				} elseif ($objp->fk_product_type == 0) {
					if ($tab_prod[$x]['stock'] == null || 0) {
						print 'Stock: 0';
					} else {
						print 'Stock: ';
						print($tab_prod[$x]['stock']);
					}
				}

				print '</td></tr></table>';
			}
		}
	}

	/**
	 * Function pour les produit sans Catégorie
	 *
	 * @param mixed $tab_prod Tableau des produit sans Catégorie
	 */
	function traitementprod($tab_product)
	{
		global $conf, $langs;

		$sizeoftab = count($tab_product);
		print '<ul><li><a><img src="' . dol_buildpath('/catalogtreeadd/img/object_category.png', 1) . '" top="-1" />';
		print $langs->trans("Scateg") . '</a>';
		print '<ul><li>';
		for ($x = 0; $x < $sizeoftab; $x++) {
			print '<table id=tabprod><tr><td id="ref" text-align="left"><input type="text" size="3" class="selectprod" data-idfournprice="' . $tab_product[$x]['rowid'] . '" data-idprod="' . $tab_product[$x]['rowid'] . '" data-refprod="' . $tab_product[$x]['ref'] . '" />&nbsp;';
			if (($tab_product[$x]['stock'] <= 0) && ($tab_product[$x]['fk_product_type']) != 1 && !empty($conf->stock->enabled)) {
				print '<img src="' . DOL_URL_ROOT . '/theme/eldy/img/statut8.png"></img> ';
			} else {
				(print '<img src="' . DOL_URL_ROOT . '/theme/eldy/img/statut4.png"></img> ');
			}
			print($tab_product[$x]['ref']);
			print '</td><td id="label" text-align="left" ><strong>';
			print($tab_product[$x]['label']);
			print "<br /></strong>";
			print($tab_product[$x]['description']);
			print '</td><td id="prix" align="right">';
			print price($tab_product[$x]['price'], null, null, null, null, $conf->global->MAIN_MAX_DECIMALS_UNIT,
				$conf->currency);
			print '</td><td id="stock" text-align="left">';
			if ($tab_product[$x]['fk_product_type'] == 1 || empty($conf->stock->enabled)) {
				print ('');
			} elseif ($objpo->fk_product_type == 0) {
				if ($tab_product[$x]['stock'] == null || 0) {
					print 'Stock: 0';
				} else {
					print 'Stock: ';
					print($tab_product[$x]['stock']);
				}
			}

			print '</td></tr></table></a>';
		}

		print '</li></ul>';
		print '</li></ul>';
	}

	/**
	 * Function des Catégories et sous Catégories
	 *
	 * @param mixed $tab_cat Tableau des Catégories
	 * @param mixed $pere Catégorie Père, permet de positionner les sous-catégories
	 * @param mixed $rang Evite une boucle sans fin
	 * @param mixed $tab_prod Tableau des produits
	 */
	function traitement($tab_cat, $pere, $rang, $tab_prod)
	{
		if ($rang > 100) {
			return;
		}
		$sizeoftab = count($tab_cat);
		for ($x = 0; $x < $sizeoftab; $x++) {
			if ($tab_cat[$x]['fk_parent'] == $pere) {
				print '<ul><li><a><img src="' . dol_buildpath('/catalogtreeadd/img/object_category.png',
						1) . '" top="-1"></img>  ';
				print $tab_cat[$x]['label'];
				print '</a>';
				$this->traitement($tab_cat, $tab_cat[$x]['rowid'], $rang + 1, $tab_prod);
				print '<ul><li>';
				$this->traitement_prod($tab_prod, $tab_cat[$x]['rowid']);
				print '</li></ul>';
				print '</li></ul>';
			}
		}
	}

	function formCreateProductSupplierOptions($parameters, &$object, &$action, $hookmanager)
	{
		global $langs, $conf, $db;
		$error = 0; // Error counter
		//print_r($parameters);
		// Permet de redimensionner la fenêtre du scroll
		$nbhaut = $conf->global->CATALOGTREEADD_HAUTEUR - 66;
		//Modifie la dimension du sous tableau
		$nbwrapper = $conf->global->CATALOGTREEADD_LARGEUR - 50;


		echo '
            <html>
            <head>
            <!--- Début CSS --->
            <style>
            /* Debut CSS Modale */

            a {color:#333; text-decoration:none;}
            a:hover {color:#ccc; text-decoration:none;}

            #mask {
            position:absolute;
            left:0;
            top:0;
            z-index:9000;
            background-color:#000;
            display:none;
            }

            #boxes .window {
            position:fixed;
            left:0;
            top:0;
            width:440px;
            height:200px;
            display:none;
            z-index:9999;
            padding:20px;
            }

            #boxes #dialog {
            width:' . $conf->global->CATALOGTREEADD_LARGEUR . 'px;
            height:' . $conf->global->CATALOGTREEADD_HAUTEUR . 'px;
            padding:10px;
            border-radius: 10px;
            background-color:white;
            }

            /* Debut CSS Treeview */

            div#Pcp {
            padding-left: 25px;
            }
            #tabprod{
            width:100%
            }
            #ref{
            width:35%;
            }
            #label {
            width: 35%;
            }
            #prix {
            width: 15%;
            }
            #stock {
            width: 15%;
            }
            a {
            color: #3B4C56;
            text-decoration: none;
            }
            a{
            cursor:pointer;
            }
            .tree ul {
            list-style: none outside none;
            padding-left:20px;
            margin: 5px;
            }
            .tree li a {
            line-height: 10px;
            }
            .tree > ul > li > a {
            color: #3B4C56;
            display: block;
            font-weight: normal;
            position: relative;
            text-decoration: none;
            }
            .tree li.parent > a {
            padding: 0 0 2px 15px;
            }
            .tree li.parent > a:before {
            background-image: url("../../includes/jquery/plugins/jquerytreeview/images/plus.gif");
            background-position:  center;
            content: "";
            display: block;
            height: 9px;
            left: 0px;
            position: absolute;
            top: 5px;
            vertical-align: middle;
            width: 9px;
            }
            .tree ul li.active > a:before {
            background-image: url("../../includes/jquery/plugins/jquerytreeview/images/minus.gif");
            background-position: 0 center;
            }
            .tree ul li ul {
            border-left: 2px solid #D9DADB;
            display: none;
            margin: 0 0 0 4px;
            overflow: hidden;
            padding: 0 0 0 25px;
            }
            .tree ul li ul li {
            position: relative;
            padding: 0 0 0 px;
            }
            .tree ul li ul li:before {
            border-bottom: 1px dashed #E2E2E3;
            content: "";
            left: -20px;
            positio$sortfn: absolute;
            top: 12px;
            width: 15px;
            }
            #wrapper {
            margin: left;
            width: ' . $nbwrapper . ';
            }

            </style>
            <!-- Fin CSS- -->
            </head>
            <!-- Mask to cover the whole screen -->
            <div id="mask"></div>
            <body>';
		if (preg_match('#commande#', $_SERVER['REQUEST_URI'])) {
			include_once DOL_DOCUMENT_ROOT . '/fourn/class/fournisseur.commande.class.php';

			$object = new CommandeFournisseur($db);
			$object->fetch(GETPOST('id'));

			echo '<input href="#dialog" name="modal" type="button" class="button" id="mod1" data-u="' . dol_buildpath('catalogtreeadd',
					1) . '" data-supplier="' . $object->fourn_id . '" data-type="suppliercmd" data-idp="' . GETPOST('id') . '" value="' . $langs->trans("Parcour") . '">';
		} elseif (preg_match('#facture#', $_SERVER['REQUEST_URI'])) {
			include_once DOL_DOCUMENT_ROOT . '/fourn/class/fournisseur.facture.class.php';

			if (GETPOSTISSET('facid')) {
				$idFac = GETPOST('facid');
			} else {
				$idFac = GETPOST('id');
			}
			$object = new FactureFournisseur($db);
			$object->fetch($idFac);

			echo '<input href="#dialog" name="modal" type="button" class="button" id="mod1"  data-u="' . dol_buildpath('catalogtreeadd',
					1) . '" data-supplier="' . $object->socid . '" data-type="supplierinv" data-idp="' . $idFac . '" value="' . $langs->trans("Parcour") . '">';
		}
		if (!empty($conf->milestone->enabled)) {
			$milestone = new ActionsMilestone($this->db);
			$m = $milestone->selectMilestoneLines($object, '', 'mileid');

		}
		echo '<div id="boxes">

            <div id="dialog" class="window" >
            <div id=Pcp align="left"><b>' . $langs->trans("ParcourCata") . '</b></div><div class="inline-block divButAction"><a class="butAction close ">' . $langs->trans("Annul") . '</a></div>
            <div style="overflow:auto; height: ' . $nbhaut . 'px; width: ' . $conf->global->CATATALOGTREEVIEW_LARGEUR . 'px;>

            <link rel="stylesheet" href="css/styletreeview.css">

            <div id="wrapper">
            <div class="tree">';
		$sortf = $conf->global->CATALOGTREEADD_TYPE;
		if (!empty($conf->categorie->enabled)) {
			$sql = "SELECT ";
			$sql .= " p.rowid, p.label, p.ref, p.description, p.fk_product_type, p.price_ttc, p.tobuy, p.price_base_type, p.tva_tx, p.duration, p.stock";
			$sql .= " ,cp.fk_categorie as id_categorie,cp.fk_product,pfp.price,pfp.remise_percent,pfp.charges, pfp.rowid as idfournprice";
			$sql .= " FROM " . MAIN_DB_PREFIX . "product as p";
			$sql .= " INNER JOIN " . MAIN_DB_PREFIX . "categorie_product as cp on p.rowid=cp.fk_product";
			$sql .= " INNER JOIN " . MAIN_DB_PREFIX . "product_fournisseur_price as pfp on pfp.fk_product=p.rowid";
			$sql .= " WHERE p.tobuy = 1 AND (pfp.fk_soc='" . $object->fourn_id . "' OR pfp.fk_soc='" . $object->socid . "')";
			$sql .= " ORDER BY cp.fk_categorie,p.$sortf";

			$resultat = $this->db->query($sql);
			$tab_prod = array();

			if ($resultat) {
				$num = $this->db->num_rows($resultat);
				$i = 0;
				while ($i < $num) {
					$objp = $this->db->fetch_object($resultat);
					$tab_prod[] = array(
						'id_categorie' => $objp->id_categorie,
						'rowid' => $objp->rowid,
						'label' => $objp->label,
						'price_ttc' => $objp->price_ttc,
						'stock' => $objp->stock,
						'ref' => $objp->ref,
						'fk_product_type' => $objp->fk_product_type,
						'description' => $objp->description,
						'price' => ($objp->price - ($objp->price * $objp->remise_percent / 100) + $objp->charges),
						'idfournprice' => $objp->idfournprice
					);
					$i++;
				}
			} else {
				$error = 1;
			}
		}
		if (!empty($conf->categorie->enabled)) {
			$sql = "SELECT ";
			$sql .= " p.rowid, p.label, p.ref, p.description, p.fk_product_type, p.price, p.price_ttc, p.tobuy, p.price_base_type, p.tva_tx, p.duration, p.stock";
			$sql .= " ,cp.fk_categorie as id_categorie,cp.fk_product";
			$sql .= " FROM " . MAIN_DB_PREFIX . "product as p";
			$sql .= " INNER JOIN " . MAIN_DB_PREFIX . "categorie_product as cp on p.rowid=cp.fk_product";
			$sql .= " WHERE p.tobuy = 1";
			$sql .= " ORDER BY cp.fk_categorie,p.$sortf";
			$resultat = $this->db->query($sql);
			$tab_prod = array();
			if ($resultat) {
				$num = $this->db->num_rows($resultat);
				$i = 0;
				while ($i < $num) {
					$objp = $this->db->fetch_object($resultat);
					$tab_prod[] = array(
						'id_categorie' => $objp->id_categorie,
						'rowid' => $objp->rowid,
						'label' => $objp->label,
						'price_ttc' => $objp->price_ttc,
						'stock' => $objp->stock,
						'price' => $objp->price,
						'ref' => $objp->ref,
						'fk_product_type' => $objp->fk_product_type,
						'description' => $objp->description
					);
					$i++;
				}
			} else {
				$error = 1;
			}
		}

		if (!empty($conf->categorie->enabled)) {
			$sql = "SELECT ";
			$sql .= "p.rowid, p.label, p.ref, p.description, p.fk_product_type, p.price, p.price_ttc, p.tobuy,";
			$sql .= "p.price_base_type, p.tva_tx, p.duration, p.stock ";
			$sql .= "FROM " . MAIN_DB_PREFIX . "product as p WHERE p.tobuy = 1 ";
			$sql .= "AND p.rowid NOT IN (select fk_product FROM " . MAIN_DB_PREFIX . "categorie_product) ";
			$sql .= "ORDER BY p.$sortf";
		} else {
			$sql = "SELECT ";
			$sql .= "p.rowid, p.label, p.ref, p.description, p.fk_product_type, p.price, p.price_ttc, p.tobuy,";
			$sql .= "p.price_base_type, p.tva_tx, p.duration, p.stock ";
			$sql .= "FROM " . MAIN_DB_PREFIX . "product as p WHERE p.tobuy = 1 ";
			$sql .= "ORDER BY p.$sortf";
		}

		$resultat = $this->db->query($sql);

		$tab_product = array();
		if ($resultat) {
			$num = $this->db->num_rows($resultat);
			$i = 0;
			while ($i < $num) {
				$objpo = $this->db->fetch_object($resultat);
				$tab_product[] = array(
					'rowid' => $objpo->rowid,
					'ref' => $objpo->ref,
					'label' => $objpo->label,
					'price_ttc' => $objpo->price_ttc,
					'price' => $objpo->price,
					'stock' => $objpo->stock,
					'fk_product_type' => $objpo->fk_product_type,
					'description' => $objpo->description
				);
				$i++;
			}
		} else {
			($error);
		}


		if (!empty($conf->categorie->enabled)) {
			$sql = "SELECT ";
			$sql .= "rowid,fk_parent,label,type ";
			$sql .= "FROM " . MAIN_DB_PREFIX . "categorie WHERE type='0'";
			if ($sortf == 'ref') {
				$sql .= " ORDER BY rowid";
			} else {
				$sql .= " ORDER BY $sortf";
			}

			$result = $this->db->query($sql);


			$tab_cat = array();

			if ($result) {
				$num = $this->db->num_rows($result);
				$i = 0;
				while ($i < $num) {
					$objp = $this->db->fetch_object($result);
					$tab_cat[] = array(
						'rowid' => $objp->rowid,
						'fk_parent' => $objp->fk_parent,
						'label' => $objp->label
					);
					$i++;
				}
			} else {
				$error = 1;
			}
			$this->traitement($tab_cat, 0, 0, $tab_prod);
		}
		$this->traitementprod($tab_product);

		echo '
            </div>
            </div>
            </div>
            </div>
            </div>
            </body>
            </html> ';
		?>
		<script type="text/javascript" language="javascript">
			$(document).ready(function () {
				$(".selectprod").change(function () {
					const idprod = $(this).attr('data-idprod');
					const refprod = $(this).attr('data-refprod');
					const qtyprod = $(this).val();
					const idfournprice = $(this).attr('data-idfournprice');
					ajoutprod(idprod, refprod, qtyprod,idfournprice);
				});
			});
			function ajoutprod(idprod, refprod, qty, idfournprice) {
				$(document).ready(function () {
					const mod1 = $("#mod1");
					const type = mod1.attr('data-type');
					const u = mod1.attr('data-u');
					const idp = mod1.attr('data-idp');
					const vat = $("#vat").val();
					const parent = $("#select_mileid").val();
					$.ajax({
						type: "POST",
						url: "<?= dol_buildpath("/catalogtreeadd/js/ajax.php",1)?>",
						data: {
							idprod: idprod,
							refprod: refprod,
							qtyprod: qty,
							idfournprice: idfournprice,
							type: type,
							idp: idp,
							vat: vat,
							parent: parent,
							token: "<?= $_SESSION["newtoken"]?>",
							action : "add_product_line"
						}
					}).done(function (message) {
						message = JSON.parse(message)
						console.log(message);
					}).fail(function (message) {
						message = JSON.parse(message)
						console.log(message);
					});
				});
			};
		</script>
		<?php
		if (!$error) {
			return 0; // or return 1 to replace standard code
		} else {
			$this->errors[] = $langs->trans("Erreur1");
			return -1;
		}
	}

	function formCreateProductOptions($parameters, &$object, &$action, $hookmanager)
	{
		require_once DOL_DOCUMENT_ROOT . '/societe/class/societe.class.php';
		global $langs, $conf;
		$error = 0; // Error counter

		//print_r($parameters);
		// Permet de redimensionner la fenêtre du scroll
		$nbhaut = $conf->global->CATALOGTREEADD_HAUTEUR - 200;
		//Modifie la dimension du sous tableau
		$nbwrapper = $conf->global->CATALOGTREEADD_LARGEUR - 50;
		$sortf = $conf->global->CATALOGTREEADD_TYPE;

		echo '
            <html>
            <head>
            <!--- Début CSS --->
            <style>
            /* Debut CSS Modale */

            a {color:#333; text-decoration:none;}
            a:hover {color:#ccc; text-decoration:none;}

            #mask {
            position:absolute;
            left:0;
            top:0;
            z-index:9000;
            background-color:#000;
            display:none;
            }

            #boxes .window {
            position:fixed;
            left:0;
            top:0;
            width:440px;
            height:200px;
            display:none;
            z-index:9999;
            padding:20px;
            }

            #boxes #dialog {
            width:' . $conf->global->CATALOGTREEADD_LARGEUR . 'px;
            height:' . ($conf->global->CATALOGTREEADD_HAUTEUR + 50) . 'px;
            padding:10px;
            border-radius: 10px;
            background-color:white;
            }

            /* Debut CSS Treeview */

            div#Pcp {
            padding-left: 25px;
            }
            #tabprod{
            width:100%
            }
            #ref{
            width:35%;
            }
            #label {
            width: 35%;
            }
            #prix {
            width: 15%;
            }
            #stock {
            width: 15%;
            }
            a {
            color: #3B4C56;
            text-decoration: none;
            }
            a{
            cursor:pointer;
            }
            .tree ul {
            list-style: none outside none;
            padding-left:20px;
            margin: 5px;
            }
            .tree li a {
            line-height: 10px;
            }
            .tree > ul > li > a {
            color: #3B4C56;
            display: block;
            font-weight: normal;
            position: relative;
            text-decoration: none;
            }
            .tree li.parent > a {
            padding: 0 0 2px 15px;
            }
            .tree li.parent > a:before {
            background-image: url("../../includes/jquery/plugins/jquerytreeview/images/plus.gif");
            background-position:  center;
            content: "";
            display: block;
            height: 9px;
            left: 0px;
            position: absolute;
            top: 5px;
            vertical-align: middle;
            width: 9px;
            }
            .tree ul li.active > a:before {
            background-image: url("../../includes/jquery/plugins/jquerytreeview/images/minus.gif");
            background-position: 0 center;
            }
            .tree ul li ul {
            border-left: 2px solid #D9DADB;
            display: none;
            margin: 0 0 0 4px;
            overflow: hidden;
            padding: 0 0 0 25px;
            }
            .tree ul li ul li {
            position: relative;
            padding: 0 0 0 px;
            }
            .tree ul li ul li:before {
            border-bottom: 1px dashed #E2E2E3;
            content: "";
            left: -20px;
            position: absolute;
            top: 12px;
            width: 15px;
            }
            #wrapper {
            margin: left;
            width: ' . $nbwrapper . ';

            }
            .mstone,.vatselect{
                display:inline-block;
                margin-left:40px;
            }
            .choice{
                background-color:#CCC;
                padding: 10px;
                width: 70%;
            }
            .vatselect select{
                            background-color:#fff;
            }
            </style>
            <!-- Fin CSS- -->
            </head>
            <!-- Mask to cover the whole screen -->
            <div id="mask"></div>
            <body>';

		if (preg_match('#propal#', $_SERVER['REQUEST_URI'])) {
			echo '<input href="#dialog" name="modal" type="button" class="button" id="mod1" data-u="' . dol_buildpath('catalogtreeadd',
					1) . '" data-type="propal" data-idp="' . GETPOST('id') . '" value="' . $langs->trans("Parcour") . '">';
		} elseif (preg_match('#commande#', $_SERVER['REQUEST_URI'])) {
			echo '<input href="#dialog" name="modal" type="button" class="button" id="mod1" data-u="' . dol_buildpath('catalogtreeadd',
					1) . '" data-type="order" data-idp="' . GETPOST('id') . '" value="' . $langs->trans("Parcour") . '">';
		} elseif (preg_match('#facture#', $_SERVER['REQUEST_URI'])) {
			if (!empty($_GET['facid'])) {
				$idff = $_GET['facid'];
			} else {
				$idff = $_GET['id'];
			}
			echo '<input href="#dialog" name="modal" type="button" class="button" id="mod1" data-u="' . dol_buildpath('catalogtreeadd',
					1) . '" data-type="invoice" data-idp="' . $idff . '" value="' . $langs->trans("Parcour") . '">';
		}
		if (!empty($conf->milestone->enabled)) {
			$milestone = new ActionsMilestone($this->db);
			$m = $milestone->selectMilestoneLines($object, '', 'mileid');

		}

		echo '<div id="boxes">

            <div id="dialog" class="window" >
                        <br /><br />' . $langs->trans("INFOCT") . '<br />

            <div class="" style="margin: 20px 0em 20px 0em; padding: 0em 0em; text-align: right;"><div id=Pcp align="left"><b>' . $langs->trans("ParcourCata") . '</b><br /><div class="choice">';
		if (!empty($conf->milestone->enabled)) {
			echo "<div class='mstone'>" . $langs->trans('Milestone') . ':' . $m . '</div>';
		}
		global $mysoc, $db;
		$buyer = new Societe($db);
		$buyer->fetch($object->socid);
		$form = new Form($db);
		print '<div class="vatselect">' . $langs->trans('VAT');
		if ($buyer->tva_assuj == "0") {
			echo '<input type="hidden" name="tva_tx" id="tva_tx" value="0">' . vatrate(0, true);
		} else {
			echo $form->load_tva('vat', (GETPOSTISSET("vat") ? GETPOST("tva_tx", 'alpha', 2) : -1), $mysoc, $buyer, 0, 0, '', false, 1);

		}
		print "</div>";

		print '<div class="vatselect">' . $langs->trans('defaultTVA');


		if($conf->global->Checkbox == 1 )
		{
			echo '<input type="checkbox" id="use_default_vat" name="use_default_vat" value="1" checked/>';
		}
		else
		{
			echo '<input type="checkbox" id="use_default_vat" name="use_default_vat" value="1"/>';
		}





		print "</div>";

		print '<div class="inline-block divButAction"><a class="butAction close" style="height: 10%; font-size: 12px">' . $langs->trans("Annul") . '</a></div>';
		echo '</div></div></div>
            <div style="overflow:auto; height: ' . $nbhaut . 'px; width: ' . $conf->global->CATALOGTREEADD_LARGEUR . 'px;>
            <link rel="stylesheet" href="css/styletreeview.css">
            <div id="wrapper">
            <div class="tree">';

		$sql = "SELECT count(rowid) AS nb FROM " . MAIN_DB_PREFIX . "product_customer_price WHERE fk_soc = " . $object->socid;
		$res = $this->db->query($sql);
		if ($conf->global->PRODUIT_CUSTOMER_PRICES && $this->db->fetch_object($res)->nb > 0) {
//			if (!empty($conf->categorie->enabled)) {
//				$sql = "SELECT ";
//				$sql .= " p.rowid, p.label, p.ref, p.description, p.fk_product_type, p.price, p.price_ttc, p.tosell, p.price_base_type, p.tva_tx, p.duration, p.stock";
//				$sql .= " ,cp.fk_categorie as id_categorie,cp.fk_product";
//				$sql .= " FROM (SELECT * FROM " . MAIN_DB_PREFIX . "product WHERE rowid NOT IN (SELECT fk_product FROM " . MAIN_DB_PREFIX . "product_customer_price)) as p";
//				$sql .= " INNER JOIN " . MAIN_DB_PREFIX . "categorie_product as cp on p.rowid=cp.fk_product";
//				$sql .= " WHERE p.tosell = 1";
//				$sql .= " ORDER BY cp.fk_categorie,p.$sortf";
//				$resultat = $this->db->query($sql);
//
//				$tab_prod = array();
//
//				if ($resultat) {
//					$num = $this->db->num_rows($resultat);
//					$i = 0;
//					while ($i < $num) {
//						$objp = $this->db->fetch_object($resultat);
//						$tab_prod[] = array(
//							'id_categorie' => $objp->id_categorie,
//							'rowid' => $objp->rowid,
//							'label' => $objp->label,
//							'price_ttc' => $objp->price_ttc,
//							'stock' => $objp->stock,
//							'price' => $objp->price,
//							'ref' => $objp->ref,
//							'fk_product_type' => $objp->fk_product_type,
//							'description' => $objp->description
//						);
//						$i++;
//					}
//				} else {
//					$error = 1;
//				}
//
//				$sql = "SELECT ";
//				$sql .= " p.rowid, p.label, p.ref, p.description, p.fk_product_type, pcp.price, pcp.price_ttc, p.tosell, pcp.price_base_type, pcp.tva_tx, p.duration, p.stock";
//				$sql .= " ,cp.fk_categorie as id_categorie,cp.fk_product";
//				$sql .= " FROM " . MAIN_DB_PREFIX . "product as p";
//				$sql .= " INNER JOIN " . MAIN_DB_PREFIX . "categorie_product as cp on p.rowid=cp.fk_product";
//				$sql .= " INNER JOIN " . MAIN_DB_PREFIX . "product_customer_price as pcp on p.rowid=pcp.fk_product";
//				$sql .= " WHERE p.tosell = 1 AND pcp.fk_soc=" . $object->socid;
//				$sql .= " ORDER BY cp.fk_categorie,p.$sortf";
//				$resultat = $this->db->query($sql);
//
//				if ($resultat) {
//					$num = $this->db->num_rows($resultat);
//					$i = 0;
//					while ($i < $num) {
//						$objp = $this->db->fetch_object($resultat);
//						$tab_prod[] = array(
//							'id_categorie' => $objp->id_categorie,
//							'rowid' => $objp->rowid,
//							'label' => $objp->label,
//							'price_ttc' => $objp->price_ttc,
//							'stock' => $objp->stock,
//							'price' => $objp->price,
//							'ref' => $objp->ref,
//							'fk_product_type' => $objp->fk_product_type,
//							'description' => $objp->description
//						);
//						$i++;
//					}
//				} else {
//					$error = 1;
//				}
//			}

//			if (!empty($conf->categorie->enabled)) {
//				$sql = "SELECT ";
//				$sql .= "p.rowid, p.label, p.ref, p.description, p.fk_product_type, p.price, p.price_ttc, p.tosell,";
//				$sql .= "p.price_base_type, p.tva_tx, p.duration, p.stock ";
//				$sql .= "FROM (SELECT * FROM " . MAIN_DB_PREFIX . "product WHERE rowid NOT IN (SELECT fk_product FROM " . MAIN_DB_PREFIX . "product_customer_price) AND rowid NOT IN (select fk_product FROM " . MAIN_DB_PREFIX . "categorie_product)) as p ";
//				$sql .= "WHERE p.tosell = 1 ";
//				$sql .= "ORDER BY p.$sortf";
//			} else {
//				$sql = "SELECT ";
//				$sql .= "p.rowid, p.label, p.ref, p.description, p.fk_product_type, p.price, p.price_ttc, p.tosell,";
//				$sql .= "p.price_base_type, p.tva_tx, p.duration, p.stock ";
//				$sql .= "FROM (SELECT * FROM " . MAIN_DB_PREFIX . "product WHERE rowid NOT IN (SELECT fk_product FROM " . MAIN_DB_PREFIX . "product_customer_price)) as p ";
//				$sql .= "WHERE p.tosell = 1 ";
//				$sql .= "ORDER BY p.$sortf";
//			}
//			$resultat = $this->db->query($sql);
//			$tab_product = array();
//			if ($resultat) {
//				$num = $this->db->num_rows($resultat);
//				$i = 0;
//				while ($i < $num) {
//					$objpo = $this->db->fetch_object($resultat);
//					$tab_product[] = array(
//						'rowid' => $objpo->rowid,
//						'ref' => $objpo->ref,
//						'label' => $objpo->label,
//						'price_ttc' => $objpo->price_ttc,
//						'price' => $objpo->price,
//						'stock' => $objpo->stock,
//						'fk_product_type' => $objpo->fk_product_type,
//						'description' => $objpo->description
//					);
//					$i++;
//				}
//			} else {
//				($error);
//			}

//			if (!empty($conf->categorie->enabled)) {
//				$sql = "SELECT ";
//				$sql .= "p.rowid, p.label, p.ref, p.description, p.fk_product_type, pcp.price, pcp.price_ttc, p.tosell,";
//				$sql .= "pcp.price_base_type, pcp.tva_tx, p.duration, p.stock ";
//				$sql .= "FROM (SELECT * FROM " . MAIN_DB_PREFIX . "product WHERE rowid NOT IN (select fk_product FROM " . MAIN_DB_PREFIX . "categorie_product)) AS p ";
//				$sql .= "INNER JOIN " . MAIN_DB_PREFIX . "product_customer_price as pcp on p.rowid=pcp.fk_product ";
//				$sql .= "WHERE p.tosell = 1 AND pcp.fk_soc=" . $object->socid;
//				$sql .= " ORDER BY p.$sortf";
//			} else {
//				$sql = "SELECT ";
//				$sql .= "p.rowid, p.label, p.ref, p.description, p.fk_product_type, pcp.price, pcp.price_ttc, p.tosell,";
//				$sql .= "pcp.price_base_type, pcp.tva_tx, p.duration, p.stock ";
//				$sql .= "FROM " . MAIN_DB_PREFIX . "product as p ";
//				$sql .= "INNER JOIN " . MAIN_DB_PREFIX . "product_customer_price as pcp on p.rowid=pcp.fk_product ";
//				$sql .= "WHERE p.tosell = 1 AND pcp.fk_soc=" . $object->socid;
//				$sql .= " ORDER BY p.$sortf";
//			}
//			$resultat = $this->db->query($sql);
//			if ($resultat) {
//				$num = $this->db->num_rows($resultat);
//				$i = 0;
//				while ($i < $num) {
//					$objpo = $this->db->fetch_object($resultat);
//					$tab_product[] = array(
//						'rowid' => $objpo->rowid,
//						'ref' => $objpo->ref,
//						'label' => $objpo->label,
//						'price_ttc' => $objpo->price_ttc,
//						'price' => $objpo->price,
//						'stock' => $objpo->stock,
//						'fk_product_type' => $objpo->fk_product_type,
//						'description' => $objpo->description
//					);
//					$i++;
//				}
//			} else {
//				($error);
//			}


//			if (!empty($conf->categorie->enabled)) {
//				$sql = "SELECT ";
//				$sql .= "rowid,fk_parent,label,type ";
//				$sql .= "FROM " . MAIN_DB_PREFIX . "categorie WHERE type='0'";
//				if ($sortf == 'ref') {
//					$sql .= " ORDER BY rowid";
//				} else {
//					$sql .= " ORDER BY $sortf";
//				}
//
//				$result = $this->db->query($sql);
//
//
//				$tab_cat = array();
//
//				if ($result) {
//					$num = $this->db->num_rows($result);
//					$i = 0;
//					while ($i < $num) {
//						$objp = $this->db->fetch_object($result);
//						$tab_cat[] = array(
//							'rowid' => $objp->rowid,
//							'fk_parent' => $objp->fk_parent,
//							'label' => $objp->label
//						);
//						$i++;
//					}
//				} else {
//					$error = 1;
//				}
//				$this->traitement($tab_cat, 0, 0, $tab_prod);
//			}
//			$this->traitementprod($tab_product);
		} else {
			if (!empty($conf->categorie->enabled)) {
				$sql = "SELECT ";
				$sql .= " p.rowid, p.label, p.ref, p.description, p.fk_product_type, p.price, p.price_ttc, p.tosell, p.price_base_type, p.tva_tx, p.duration, p.stock";
				$sql .= " ,cp.fk_categorie as id_categorie,cp.fk_product";
				$sql .= " FROM " . MAIN_DB_PREFIX . "product as p";
				$sql .= " INNER JOIN " . MAIN_DB_PREFIX . "categorie_product as cp on p.rowid=cp.fk_product";
				$sql .= " WHERE p.tosell = 1";
				$sql .= " ORDER BY cp.fk_categorie,p.$sortf";
				$resultat = $this->db->query($sql);
				$tab_prod = array();
				if ($resultat) {
					$num = $this->db->num_rows($resultat);
					$i = 0;
					while ($i < $num) {
						$objp = $this->db->fetch_object($resultat);
						$tab_prod[] = array(
							'id_categorie' => $objp->id_categorie,
							'rowid' => $objp->rowid,
							'label' => $objp->label,
							'price_ttc' => $objp->price_ttc,
							'stock' => $objp->stock,
							'price' => $objp->price,
							'ref' => $objp->ref,
							'fk_product_type' => $objp->fk_product_type,
							'description' => $objp->description
						);
						$i++;
					}
				} else {
					$error = 1;
				}
			}

			if (!empty($conf->categorie->enabled)) {
				$sql = "SELECT ";
				$sql .= "p.rowid, p.label, p.ref, p.description, p.fk_product_type, p.price, p.price_ttc, p.tosell,";
				$sql .= "p.price_base_type, p.tva_tx, p.duration, p.stock ";
				$sql .= "FROM " . MAIN_DB_PREFIX . "product as p WHERE p.tosell = 1 ";
				$sql .= "AND p.rowid NOT IN (select fk_product FROM " . MAIN_DB_PREFIX . "categorie_product) ";
				$sql .= "ORDER BY p.$sortf";
			} else {
				$sql = "SELECT ";
				$sql .= "p.rowid, p.label, p.ref, p.description, p.fk_product_type, p.price, p.price_ttc, p.tosell,";
				$sql .= "p.price_base_type, p.tva_tx, p.duration, p.stock ";
				$sql .= "FROM " . MAIN_DB_PREFIX . "product as p WHERE p.tosell = 1 ";
				$sql .= "ORDER BY p.$sortf";
			}

			$resultat = $this->db->query($sql);

			$tab_product = array();
			if ($resultat) {
				$num = $this->db->num_rows($resultat);
				$i = 0;
				while ($i < $num) {
					$objpo = $this->db->fetch_object($resultat);
					$tab_product[] = array(
						'rowid' => $objpo->rowid,
						'ref' => $objpo->ref,
						'label' => $objpo->label,
						'price_ttc' => $objpo->price_ttc,
						'price' => $objpo->price,
						'stock' => $objpo->stock,
						'fk_product_type' => $objpo->fk_product_type,
						'description' => $objpo->description
					);
					$i++;
				}
			} else {
				($error);
			}

			if (!empty($conf->categorie->enabled)) {
				$sql = "SELECT ";
				$sql .= "rowid,fk_parent,label,type ";
				$sql .= "FROM " . MAIN_DB_PREFIX . "categorie WHERE type='0'";
				if ($sortf == 'ref') {
					$sql .= " ORDER BY rowid";
				} else {
					$sql .= " ORDER BY $sortf";
				}

				$result = $this->db->query($sql);


				$tab_cat = array();

				if ($result) {
					$num = $this->db->num_rows($result);
					$i = 0;
					while ($i < $num) {
						$objp = $this->db->fetch_object($result);
						$tab_cat[] = array(
							'rowid' => $objp->rowid,
							'fk_parent' => $objp->fk_parent,
							'label' => $objp->label
						);
						$i++;
					}
				} else {
					$error = 1;
				}
				$this->traitement($tab_cat, 0, 0, $tab_prod);
			}
			$this->traitementprod($tab_product);
		}
		echo '
            </div>
            </div>
            </div>
            </div>
            </div>
            </body>
            </html>';
		?>

		<script type="text/javascript" language="javascript">
			$(document).ready(function () {
				$(".selectprod").change(function () {
					const idprod = $(this).attr('data-idprod');
					const refprod = $(this).attr('data-refprod');
					const qtyprod = $(this).val();
					const idfournprice = $(this).attr('data-idfournprice');
					ajoutprod(idprod, refprod, qtyprod,idfournprice);
				});
			});
			function ajoutprod(idprod, refprod, qty, idfournprice) {
				$(document).ready(function () {
					const mod1 = $("#mod1");
					const type = mod1.attr('data-type');
					const u = mod1.attr('data-u');
					const idp = mod1.attr('data-idp');
					const vat = $("#vat").val();
					const useDefaultVat = $("#use_default_vat").prop('checked') ? 1 : 0;
					const parent = $("#select_mileid").val();
					$.ajax({
						type: "POST",
						url: "<?= dol_buildpath("/catalogtreeadd/js/ajax.php",1)?>",
						data: {
							idprod: idprod,
							refprod: refprod,
							qtyprod: qty,
							idfournprice: idfournprice,
							type: type,
							idp: idp,
							vat: vat,
							defaultvat: useDefaultVat,
							parent: parent,
							token: "<?= $_SESSION["newtoken"]?>",
							action : "add_product_line"
						}
					}).done(function (message) {
						message = JSON.parse(message)
						console.log(message);
					}).fail(function (message) {
						message = JSON.parse(message)
						console.log(message);
					});
				});
			};
		</script>
		<?php
		if (!$error) {
			return 0; // or return 1 to replace standard code
		} else {
			$this->errors[] = $langs->trans("Erreur1");
			return -1;
		}
	}
}
